#!/bin/bash

set -e

tmp=$(mktemp -d)

trap cleanup EXIT
cleanup() {
    set +e
    [ -z "$tmp" -o ! -d "$tmp" ] || rm -rf "$tmp"
}

unset CDPATH
pwd=$(pwd)
git=$(date +%Y%m%d)

pushd "$tmp"
git clone git://git.cinelerra.org/j6t/cinelerra.git j6t
cd j6t
./autogen.sh
./configure \
  --with-external-ffmpeg
make dist-bzip2
mv cinelerra-2.1.tar.bz2 "$pwd"/cinelerra-2.1-git$git.tar.bz2
popd >/dev/null

